/**
 * generated by Xtext
 */
package com.javadude.beans2.dsl.generator;

import com.javadude.beans2.dsl.beansDsl.ClassType;
import com.javadude.beans2.dsl.beansDsl.EnumType;
import com.javadude.beans2.dsl.beansDsl.Field;
import com.javadude.beans2.dsl.beansDsl.ListField;
import com.javadude.beans2.dsl.beansDsl.Model;
import com.javadude.beans2.dsl.beansDsl.PrimitiveType;
import com.javadude.beans2.dsl.beansDsl.SimpleField;
import com.javadude.beans2.dsl.beansDsl.Type;
import com.javadude.beans2.dsl.beansDsl.Value;
import java.util.Arrays;
import java.util.HashSet;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

/**
 * Generates code from your model files on save.
 * 
 * see http://www.eclipse.org/Xtext/documentation.html#TutorialCodeGeneration
 */
@SuppressWarnings("all")
public class BeansDslGenerator implements IGenerator {
  private HashSet<String> imports = new Function0<HashSet<String>>() {
    public HashSet<String> apply() {
      HashSet<String> _hashSet = new HashSet<String>();
      return _hashSet;
    }
  }.apply();
  
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    EList<EObject> _contents = resource.getContents();
    EObject _head = IterableExtensions.<EObject>head(_contents);
    Model model = ((Model) _head);
    EList<Type> _types = model.getTypes();
    final Function1<Type,Boolean> _function = new Function1<Type,Boolean>() {
        public Boolean apply(final Type it) {
          boolean _not = (!(it instanceof PrimitiveType));
          return Boolean.valueOf(_not);
        }
      };
    Iterable<Type> _filter = IterableExtensions.<Type>filter(_types, _function);
    for (final Type t : _filter) {
      {
        this.imports.clear();
        StringConcatenation _builder = new StringConcatenation();
        String _packageName = model.getPackageName();
        String _replace = _packageName.replace(".", "/");
        _builder.append(_replace, "");
        _builder.append("/");
        String _name = t.getName();
        _builder.append(_name, "");
        _builder.append(".java");
        CharSequence _genApi = this.genApi(t, model);
        CharSequence _gen = this.gen(_genApi, model);
        fsa.generateFile(_builder.toString(), _gen);
      }
    }
    EList<Type> _types_1 = model.getTypes();
    final Function1<Type,Boolean> _function_1 = new Function1<Type,Boolean>() {
        public Boolean apply(final Type it) {
          return Boolean.valueOf((it instanceof ClassType));
        }
      };
    Iterable<Type> _filter_1 = IterableExtensions.<Type>filter(_types_1, _function_1);
    for (final Type t_1 : _filter_1) {
      {
        this.imports.clear();
        StringConcatenation _builder = new StringConcatenation();
        String _packageName = model.getPackageName();
        String _replace = _packageName.replace(".", "/");
        _builder.append(_replace, "");
        _builder.append("/");
        String _name = t_1.getName();
        _builder.append(_name, "");
        _builder.append("Impl.java");
        CharSequence _genImpl = this.genImpl(((ClassType) t_1), model);
        CharSequence _gen = this.gen(_genImpl, model);
        fsa.generateFile(_builder.toString(), _gen);
      }
    }
  }
  
  public String imp(final String i) {
    String _xblockexpression = null;
    {
      this.imports.add(i);
      int _lastIndexOf = i.lastIndexOf(".");
      int _plus = (_lastIndexOf + 1);
      String _substring = i.substring(_plus);
      _xblockexpression = (_substring);
    }
    return _xblockexpression;
  }
  
  public String iList() {
    String _imp = this.imp("java.util.List");
    return _imp;
  }
  
  public String iArrayList() {
    String _imp = this.imp("java.util.ArrayList");
    return _imp;
  }
  
  public CharSequence gen(final CharSequence body, final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = model.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    {
      for(final String i : this.imports) {
        _builder.append("import ");
        _builder.append(i, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append(body, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence genImpl(final ClassType t, final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _name = t.getName();
    _builder.append(_name, "");
    _builder.append("Impl implements ");
    String _name_1 = t.getName();
    _builder.append(_name_1, "");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    {
      EList<Field> _fields = t.getFields();
      for(final Field f : _fields) {
        _builder.append("\t");
        CharSequence _genField = this.genField(f);
        _builder.append(_genField, "	");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        CharSequence _genMethods = this.genMethods(f);
        _builder.append(_genMethods, "	");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  protected CharSequence _genMethods(final ListField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public ");
    String _iList = this.iList();
    _builder.append(_iList, "");
    _builder.append("<");
    Type _type = f.getType();
    String _name = _type.getName();
    _builder.append(_name, "");
    _builder.append("> get");
    String _name_1 = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper, "");
    _builder.append("() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this.");
    String _name_2 = f.getName();
    _builder.append(_name_2, "	");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  protected CharSequence _genMethods(final SimpleField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public void set");
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    Type _type = f.getType();
    String _name_1 = _type.getName();
    _builder.append(_name_1, "");
    _builder.append(" ");
    String _name_2 = f.getName();
    _builder.append(_name_2, "");
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    {
      boolean _isBound = f.isBound();
      if (_isBound) {
        _builder.append("\t");
        Type _type_1 = f.getType();
        String _name_3 = _type_1.getName();
        _builder.append(_name_3, "	");
        _builder.append(" old = this.");
        String _name_4 = f.getName();
        _builder.append(_name_4, "	");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("this.");
    String _name_5 = f.getName();
    _builder.append(_name_5, "	");
    _builder.append(" = ");
    String _name_6 = f.getName();
    _builder.append(_name_6, "	");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    {
      boolean _isBound_1 = f.isBound();
      if (_isBound_1) {
        _builder.append("\t");
        _builder.append("pcs.fire...");
        _builder.newLine();
      }
    }
    _builder.append("}");
    _builder.newLine();
    _builder.append("public ");
    Type _type_2 = f.getType();
    String _name_7 = _type_2.getName();
    _builder.append(_name_7, "");
    _builder.append(" get");
    String _name_8 = f.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_8);
    _builder.append(_firstUpper_1, "");
    _builder.append("() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this.");
    String _name_9 = f.getName();
    _builder.append(_name_9, "	");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  protected CharSequence _genApiMethods(final ListField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public ");
    String _iList = this.iList();
    _builder.append(_iList, "");
    _builder.append("<");
    Type _type = f.getType();
    String _name = _type.getName();
    _builder.append(_name, "");
    _builder.append("> get");
    String _name_1 = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper, "");
    _builder.append("();");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  protected CharSequence _genApiMethods(final SimpleField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public void set");
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    Type _type = f.getType();
    String _name_1 = _type.getName();
    _builder.append(_name_1, "");
    _builder.append(" ");
    String _name_2 = f.getName();
    _builder.append(_name_2, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public ");
    Type _type_1 = f.getType();
    String _name_3 = _type_1.getName();
    _builder.append(_name_3, "");
    _builder.append(" get");
    String _name_4 = f.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_4);
    _builder.append(_firstUpper_1, "");
    _builder.append("();");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  protected CharSequence _genField(final ListField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private ");
    String _iList = this.iList();
    _builder.append(_iList, "");
    _builder.append("<");
    Type _type = f.getType();
    String _name = _type.getName();
    _builder.append(_name, "");
    _builder.append("> ");
    String _name_1 = f.getName();
    _builder.append(_name_1, "");
    _builder.append(" = new ");
    String _iArrayList = this.iArrayList();
    _builder.append(_iArrayList, "");
    _builder.append("<");
    Type _type_1 = f.getType();
    String _name_2 = _type_1.getName();
    _builder.append(_name_2, "");
    _builder.append(">();");
    return _builder;
  }
  
  protected CharSequence _genField(final SimpleField f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private ");
    Type _type = f.getType();
    String _name = _type.getName();
    _builder.append(_name, "");
    _builder.append(" ");
    String _name_1 = f.getName();
    _builder.append(_name_1, "");
    _builder.append(";");
    return _builder;
  }
  
  protected CharSequence _genApi(final ClassType t, final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public interface ");
    String _name = t.getName();
    _builder.append(_name, "");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    {
      EList<Field> _fields = t.getFields();
      for(final Field f : _fields) {
        _builder.append("\t");
        CharSequence _genApiMethods = this.genApiMethods(f);
        _builder.append(_genApiMethods, "	");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  protected CharSequence _genApi(final EnumType t, final Model model) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public enum ");
    String _name = t.getName();
    _builder.append(_name, "");
    _builder.append(" {");
    _builder.newLineIfNotEmpty();
    {
      EList<Value> _values = t.getValues();
      boolean _hasElements = false;
      for(final Value v : _values) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder.appendImmediate(", ", "	");
        }
        _builder.append("\t");
        String _name_1 = v.getName();
        _builder.append(_name_1, "	");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence genMethods(final Field f) {
    if (f instanceof ListField) {
      return _genMethods((ListField)f);
    } else if (f instanceof SimpleField) {
      return _genMethods((SimpleField)f);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(f).toString());
    }
  }
  
  public CharSequence genApiMethods(final Field f) {
    if (f instanceof ListField) {
      return _genApiMethods((ListField)f);
    } else if (f instanceof SimpleField) {
      return _genApiMethods((SimpleField)f);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(f).toString());
    }
  }
  
  public CharSequence genField(final Field f) {
    if (f instanceof ListField) {
      return _genField((ListField)f);
    } else if (f instanceof SimpleField) {
      return _genField((SimpleField)f);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(f).toString());
    }
  }
  
  public CharSequence genApi(final Type t, final Model model) {
    if (t instanceof ClassType) {
      return _genApi((ClassType)t, model);
    } else if (t instanceof EnumType) {
      return _genApi((EnumType)t, model);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(t, model).toString());
    }
  }
}
